from deepdiff import DeepDiff

from CAF.features.encoding import generate_features


def test_generate_features(oliynyk_obj):
    elements = oliynyk_obj.elements
    actual_features = generate_features("NdSi2", elements)
    expected_features = {
        "Li": 0,
        "Be": 0,
        "B": 0,
        "C": 0,
        "Na": 0,
        "Mg": 0,
        "Al": 0,
        "Si": 0.666667,
        "P": 0,
        "S": 0,
        "K": 0,
        "Ca": 0,
        "Sc": 0,
        "Ti": 0,
        "V": 0,
        "Cr": 0,
        "Mn": 0,
        "Fe": 0,
        "Co": 0,
        "Ni": 0,
        "Cu": 0,
        "Zn": 0,
        "Ga": 0,
        "Ge": 0,
        "As": 0,
        "Se": 0,
        "Rb": 0,
        "Sr": 0,
        "Y": 0,
        "Zr": 0,
        "Nb": 0,
        "Mo": 0,
        "Ru": 0,
        "Rh": 0,
        "Pd": 0,
        "Ag": 0,
        "Cd": 0,
        "In": 0,
        "Sn": 0,
        "Sb": 0,
        "Te": 0,
        "Cs": 0,
        "Ba": 0,
        "La": 0,
        "Ce": 0,
        "Pr": 0,
        "Nd": 0.333333,
        "Sm": 0,
        "Eu": 0,
        "Gd": 0,
        "Tb": 0,
        "Dy": 0,
        "Ho": 0,
        "Er": 0,
        "Tm": 0,
        "Yb": 0,
        "Lu": 0,
        "Hf": 0,
        "Ta": 0,
        "W": 0,
        "Re": 0,
        "Os": 0,
        "Ir": 0,
        "Pt": 0,
        "Au": 0,
        "Tl": 0,
        "Pb": 0,
        "Bi": 0,
        "Th": 0,
        "U": 0,
    }
    diff = DeepDiff(expected_features, actual_features, significant_digits=3)
    assert diff == {}
